#include <avr/interrupt.h>
#include <avr/io.h>
#include "usart.h"
#include "lcd.h"
#include <util/delay.h>
#include <avr/wdt.h>


//--------------------------------------------------------------------------

// Defines


//--------------------------------------------------------------------------

// Global Variables 




//----------------------------------------------------------------------------

// Compiler Defines 
#define F_CPU 1000000UL  // 1 MHz


// External Interrupt 0 service routine

//ISR(INT0_vect)       /* veraltet: SIGNAL(SIG_INTERRUPT0) */
//{

//cli();
/*
if ((PIND && 0x04) == 1)
//if (debounce(PIND, 2))
    {   
		i++;
		PORTA |= ( 1 << 0 );
	}
	else PORTA &= ~0x01;
	*/
//sei();



//}


//ISR (TIMER0_OVF_vect)
//{
  /* Interrupt Aktion alle
  (1000000/8)/256 Hz = 488,28125 Hz
  bzw.
  1/488,28125 s = 2,048 ms  
  */
  
  
//}

//------------------------------------------------------------------------------


/*
void init_timer0(void)
{
// Init Timer0+OV-Interrupt
// Timer 0 konfigurieren
  TCCR0 = (1<<CS01); // Prescaler 8
 
  // Overflow Interrupt erlauben
  TIMSK |= (1<<TOIE0);
}*/


//-----------------------------------------------------------------------------


void init_extInt(void)
{
// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
// INT1: Off
// INT2: Off
GICR|=0x40;
MCUCR=0x02;
MCUCSR=0x00;
GIFR=0x40;
}


void initPort(void)
{
// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=T State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTA=0x00;
DDRA=0xFF;
} 







//------------------------------------------------------------------------------

/*
int debounce(volatile int *port, int pin)
{
    if ( ! (*port & (1 << pin)) )
    {
        // Pin wurde auf Masse gezogen, 100ms warten 
        _delay_ms(5);  // max. 262.1 ms / F_CPU in MHz
        _delay_ms(5);
    
        if ( *port & (1 << pin) )
        {
            // Anwender Zeit zum Loslassen des Tasters geben 
            _delay_ms(5);
            _delay_ms(5); 
            return 1;
        }
    }
    return 0;
}
*/

//------------------------------------------------------------------------------


int main (void) 
{
	
	
	initPort();
	//init_timer0();
	//init_extInt();
	
	

	
	
	//usart_init(9600); // Serielle Schnittstelle initialisieren
	//usart_write("%2i LC-Display V1.5\r\n",a); 


	//BEISPIEL TESTAUSGABE:
	//lcd_print(0,0,"%2i.%2i.%4i RX: %i",day,mon,year,flags.dcf_rx);


	
	lcd_init();
	//lcd_clear();
	lcd_gotoxy(0,0);
	lcd_print(0,0,"");
	
	
	
	//lcd_print(0,0,"%s",FERIEN-");
	//lcd_print(1,0,"SPA2010");
	//lcd_print(0,8,"%d cm/Imp",IMPULS_WEG);
	
	
	// Global Interrupts aktivieren
	// sei();
	
	while(1)
	{
		
		//lcd_init();
		//lcd_clear();
		//lcd_print(0,0,"FERIEN-");
		//lcd_print(1,0,"SPASS 2010");	
		//_delay_ms(1000);
		//wdt_reset();
	
	}
}

